functions 4.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169
  1. #!/usr/bin/env bash
  2. export ZWAVE_JS_CONF="${SNAP}/lib/zwavejs2mqtt/node_modules/@zwave-js/config"
  3. function ensure_zwavejs_config {
  4. # Not needed anymore as of ZWAVEJS_EXTERNAL_CONFIG
  5. # if [ "$(find ${ZWAVE_JS_CONF} -maxdepth 0 -empty -exec echo empty \;)" == "empty" ]; then
  6. # logger "Config directory is empty, copying data from ${SNAP}/snap/zwave-js/config"
  7. # rsync -raz "${SNAP}/snap/zwave-js/config" "${ZWAVE_JS_CONF}/.."
  8. # else
  9. # logger "Config directory ${ZWAVE_JS_CONF} exists"
  10. # fi
  11. return 0
  12. }
  13. function get_network_key {
  14. if [ -f "${SNAP_DATA}/settings.json" ]; then
  15. SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  16. if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  17. echo "${SETTINGS_KEY}"
  18. return 1
  19. fi
  20. return 0
  21. fi
  22. return 0
  23. }
  24. function same_network_key {
  25. # SKIP NOW: NETWORK KEY SHOULD NOT BE USED
  26. # FAVOR SETTING
  27. # if [ -f "${SNAP_DATA}/settings.json" ]; then
  28. # SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  29. # if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  30. # echo "${SETTINGS_KEY}"
  31. # return 1
  32. # fi
  33. # return 0
  34. # fi
  35. return 0
  36. }
  37. function cpy_2_zui {
  38. if snapctl is-connected zui-store; then
  39. if [ -d "${SNAP_COMMON}/zui-store" ]; then
  40. cp -rf "${SNAP_DATA}/"* "${SNAP_COMMON}/zui-store"
  41. if [ $? -ne 0 ]; then
  42. echo "Failed copying data from ${SNAP_COMMON}/zui-store";
  43. return 1;
  44. fi
  45. else
  46. echo "Missing directory ${SNAP_COMMON}/zui-store, cannot write to it. Exiting..." >&2
  47. exit 1;
  48. fi
  49. else
  50. echo "Cannot copy config: Missing connection «store-dir» (offered by <zwave-js-ui>: `snap install zwave-js-ui`)." >&2
  51. return 1
  52. fi
  53. return 0;
  54. }
  55. function plug_connected {
  56. if ! snapctl is-connected "${1}"; then
  57. echo "Missing plug: «${1}»" >&2
  58. echo "Connect with:"
  59. if [ "${1}" == "serial-port" ]; then
  60. echo "$ sudo snap connect ${SNAP_NAME}:${1} <slot name>"
  61. else
  62. echo "$ sudo snap connect ${SNAP_NAME}:${1}"
  63. fi
  64. return 1
  65. fi
  66. return 0
  67. }
  68. function plugs_connected {
  69. MISSING=0
  70. RAW_OUT=$(plug_connected "raw-usb")
  71. RAW_RES=$?
  72. SERIAL_OUT=$(plug_connected "serial-port")
  73. SERIAL_RES=$?
  74. if [ $RAW_RES -ne 0 -a $SERIAL_RES -ne 0 ]; then
  75. echo $RAW_OUT
  76. echo "----- OR -----"
  77. echo $SERIAL_OUT
  78. echo "See ${SNAP_NAME}.help for more info on the serial-port plug"
  79. MISSING=1
  80. fi
  81. plug_connected "hardware-observe"
  82. if [ $? -ne 0 ]; then
  83. MISSING=1
  84. fi
  85. if [ $MISSING -ne 0 ]; then
  86. return 1
  87. fi
  88. return 0
  89. }
  90. function is_root {
  91. if [ ${EUID:-$(id -u)} -eq 0 ]; then
  92. return 0
  93. fi
  94. return 1
  95. }
  96. function require_root {
  97. is_root
  98. if [ $? -eq 1 ]; then
  99. echo "Running as root is required." >&2
  100. echo "Re-run with sudo."
  101. exit 1
  102. fi
  103. }
  104. function testnset_config {
  105. logger "${SNAP_NAME}: Testing ${1}, or setting ${2}"
  106. RES=$(snapctl get ${1})
  107. if [ $? -ne 0 ] || [ -z "${RES}" ]; then
  108. logger "${SNAP_NAME}: Setting ${1}=${2}"
  109. RES=$(snapctl set ${1}=${2})
  110. if [ $? -ne 0 ]; then
  111. logger "${RES}"
  112. exit 1
  113. fi
  114. return 0
  115. fi
  116. return 0
  117. }
  118. function test_priority_dir {
  119. Z2M_SETTINGS="${SNAP_DATA}/settings.json"
  120. if ! [ -w "${Z2M_SETTINGS}" ]; then
  121. return 1
  122. fi
  123. PRIORITY_DIR=$(echo "$(sed -E "s#$(dirname ${SNAP_DATA})/(current|[0-9]+)#${SNAP_DATA}#g" <<< $(cat "${Z2M_SETTINGS}" | jq '.zwave.deviceConfigPriorityDir'))" | tr -d '"')
  124. if [[ -d $(dirname "${PRIORITY_DIR}") && -w "${PRIORITY_DIR}" ]]; then
  125. jq --arg deviceConfigPriorityDir ${PRIORITY_DIR} '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  126. if [ $? -eq 0 ]; then
  127. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  128. fi
  129. elif ! [[ "${PRIORITY_DIR}" =~ ^"$(dirname $SNAP_DATA)"* ]]; then
  130. jq --arg deviceConfigPriorityDir "${SNAP_DATA}/devicePriorityConfig" '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  131. if [ $? -eq 0 ]; then
  132. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  133. fi
  134. fi
  135. return 0
  136. }
  137. function test_default_config {
  138. testnset_config "server.host" "localhost"
  139. testnset_config "server.port" 8091
  140. testnset_config "server.ssl" false
  141. testnset_config "server.force-disable-ssl" false
  142. testnset_config "session.cookie-secure" $(snap get server.ssl)
  143. testnset_config "session.secret" $(uuid)
  144. testnset_config "mqtt.name" ""
  145. }